#!/usr/bin/python

import spidev
import time
import sys
import signal

spi = spidev.SpiDev()
spi.open(0,0)
spi.max_speed_hz=115200

# catch control-c
def signal_handler(signal, frame):
  print '\n** Control-C Detected'
  # cleanup whatever here
  spi.close()

  sys.exit(0)

#
# Read specified MCP23S17 register (16 bits)
#

def readDio(reg):
    r = spi.xfer([0x41,reg,0,0])
    return ((r[2]<<8)+r[3])

#
# Print out contents of all the MCP23S17 registers (16 bit)
#

def dumpDio():
    print "reg val"
    print "--------"
    for r in range(0,16):
        print "", format(r+r, '02X'), format(readDio(r+r),'04X')



signal.signal(signal.SIGINT, signal_handler)


spi.xfer([0x40,0,0])  #write=0x40, reg IODIRA=0, all pins outputs=0
spi.xfer([0x40,1,0])  #write=0x40, reg IODIRB=1, all pins outputs=0
# since did not disable auto address incrementing, this is same
spi.xfer([0x40,0,0,0]) # write, start at reg IODIRA, vals for IODIRA, vals for IODIRB


while True:
 print "All pins low"
 spi.xfer([0x40,0x12,0]) # write=0x40, reg GPIOA=0x12, all pins low=0
 spi.xfer([0x40,0x13,0]) # write=0x40, reg GPIOB=0x13, all pins low=0
 dumpDio()
 time.sleep(1)
 
 print "All pins high"
 spi.xfer([0x40,0x12,0xFF]) # write=0x40, reg GPIOA=0x12, all pins high=0xFF
 spi.xfer([0x40,0x13,0xFF]) # write=0x40, reg GPIOA=0x13, all pins high=0xFF
 dumpDio()
 time.sleep(1)
